﻿using Carmenta.Engine;
using CarmentaWpfClient.Utils;

using CommunityToolkit.Mvvm.ComponentModel;

using System.Collections.Generic;
using System.Linq;

namespace CarmentaWpfClient.Models
{
    public partial class MapModel
    {
        public MapModel(string configurationPath)
        {
            var configuration = new Configuration(configurationPath);

            // Load the first View object from the configuration
            View = configuration.PublicNames.Select(name => configuration.GetPublicObject(name)).OfType<View>().First();
            Name = string.IsNullOrEmpty(View.DisplayName) ? View.Name : View.DisplayName;

            Layers = View.Layers.Select(x => new LayerModel(x));
        }

        public void Update() => View?.Update();

        public string Name { get; }

        public IEnumerable<LayerModel> Layers { get; }

        public View View { get; }

        public MemoryDataSet? GetMemoryDataSet(string name) => View.GetTypedObject<MemoryDataSet>(name);
    }
}
