﻿using Carmenta.Engine;
using System;
using System.IO;

namespace CarmentaWpfClient.Utils;

public class BinaryFeatureSerializer : IFeatureSerializer
{
    public Feature Deserialize(byte[] buffer)
    {
        using var stream = new MemoryStream(buffer);
        stream.Seek(0, SeekOrigin.Begin);

        return Feature.FromStream(stream);
    }

    public byte[] Serialize(Feature feature)
    {
        using Stream? stream = feature.Save(FeatureSaveMode.XYZ);

        var buffer = new byte[stream.Length];
        stream.Read(buffer, 0, buffer.Length);

        return buffer;
    }
}
