﻿using CarmentaWpfClient.Messages;

using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;

namespace CarmentaWpfClient.ViewModels
{
    public partial class MainViewModel(MapViewModel mapViewModel, DrawerMenuViewModel drawerMenuViewModel) : ObservableObject
    {
        public MapViewModel MapViewModel { get; } = mapViewModel;

        public DrawerMenuViewModel DrawerMenuViewModel { get; } = drawerMenuViewModel;

        [RelayCommand]
        private void ResetTool()
        {
            WeakReferenceMessenger.Default.Send(new ChangeToolMessage(ToolType.Standard));
        }

        [RelayCommand]
        private void DeleteFeatures()
        {
            WeakReferenceMessenger.Default.Send(new DeleteSelectedFeatures());
        }
    }
}
