﻿using Carmenta.Engine;

using CarmentaWpfClient.Messages;

using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;

namespace CarmentaWpfClient.ViewModels
{
    public partial class ToolsMenuViewModel : ObservableObject
    {
        [RelayCommand]
        public void ItemSelected(string? tag)
        {
            if (tag is null) return;

            ChangeToolMessage message = tag switch
            {
                "point" => new ChangeToolMessage(ToolType.Create, ToolCreateMode.Point),
                "line" => new ChangeToolMessage(ToolType.Create, ToolCreateMode.Line),
                "polygon" => new ChangeToolMessage(ToolType.Create, ToolCreateMode.Polygon),
                _ => new ChangeToolMessage(ToolType.Standard),
            };
            WeakReferenceMessenger.Default.Send(message);
        }
    }
}
