﻿using CarmentaWpfClient.ViewModels;

using System.Windows;
using System.Windows.Controls;

namespace CarmentaWpfClient.Views
{
    /// <summary>
    /// Interaction logic for MapView.xaml
    /// </summary>
    public partial class MapView : UserControl
    {
        public MapView()
        {
            InitializeComponent();
        }

        private void OnDataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            if (e.NewValue is MapViewModel mapViewModel)
            {
                mapViewModel.PropertyChanged += OnPropertyChanged;
                MapControl.View = mapViewModel.CurrentMap.View;
                MapControl.Tool = mapViewModel.CurrentTool;
            }
        }

        private void OnPropertyChanged(object? sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (sender is not MapViewModel mapViewModel)
                return;

            if (e.PropertyName == nameof(MapViewModel.CurrentTool))
                MapControl.Tool = mapViewModel.CurrentTool;
        }
    }
}
